stages:
    - build_and_test
    - check_warnings


# As suggested by https://blog.sparksuite.com/7-ways-to-speed-up-gitlab-ci-cd-times-29f60aab69f9
variables:
  DOCKER_DRIVER: overlay2


.build_template_linux: &build_template_linux
    stage: build_and_test
    except:
        - master
    image: registry.gitlab.inria.fr/morefem/corelibrary/morefem/${OS}_${COMPILER}_${MODE}_shared
    cache:
        key: "cache_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_MoReFEM_${OS}-${COMPILER}-${MODE}"
        untracked: true
        paths:
            - build
    artifacts:
        name: "artifact_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_MoReFEM_${OS}-${COMPILER}-${MODE}"
        expire_in: 2 days
        when: always
        paths:
            - build/compilation.log
    script:
        - mkdir -p build
        - cd build && python /opt/MoReFEM/cmake/configure_cmake_external_model.py --morefem_install_dir=/opt/MoReFEM --cmake_args="-G Ninja"
        - ninja |& tee compilation.log
        - ctest --output-on-failure
    after_script:
        # Remove the final targets that might be huge with static library, as cache creation could be beforehand
        # more than 80 % of the time spent on the job in the worst cases!
        - mv build/Sources/CMakeFiles Tmp
        - rm -rf build/Sources
        - mkdir -p build/Sources
        - mv Tmp build/Sources/CMakeFiles
        
        
.build_template_macos: &build_template_macos
    stage: build_and_test
    tags:
        - macos
    except:
        - master        
    cache:
        key: "cache_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_MoReFEM_${OS}-${COMPILER}-${MODE}"
        untracked: true
        paths:
            - build
    artifacts:
        name: "artifact_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_MoReFEM_${OS}-${COMPILER}-${MODE}"
        expire_in: 2 days
        when: always
        paths:
            - build/compilation.log
    script:
        - mkdir -p build
        - conda activate Python3
        - cd build && python /Volumes/Data/ci/opt/clang_${MODE}/MoReFEM/cmake/configure_cmake_external_model.py  --morefem_install_dir=/Volumes/Data/ci/opt/clang_${MODE}/MoReFEM --cmake_args="-G Ninja"
        - ninja 2>&1 | tee compilation.log
        - ctest --output-on-failure 
    

.check_compilation_warning_template_docker: &check_compilation_warning_template_docker
    stage: check_warnings
    except:
        - master
    image: registry.gitlab.inria.fr/morefem/corelibrary/morefem/${OS}_${COMPILER}_${MODE}_shared
    # dependencies: in the instantiations!
    script:
        - python /opt/MoReFEM/share/find_warning_in_compilation_log.py --log build/compilation.log
    allow_failure: true
    
    
.check_compilation_warning_template_macos: &check_compilation_warning_template_macos
    stage: check_warnings
    except:
        - master
    # dependencies: in the instantiations!
    script:
        - python /Volumes/Data/ci/opt/clang_${MODE}/MoReFEM/share/find_warning_in_compilation_log.py --log build/compilation.log
    allow_failure: true    
    
